#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "functions.h"
#include "util.h"
#include "plist.h"

void value(POINT *parent, POINT *point, int timeslice){
  POINT scratch_point;
  char string[1024];

  if(Trace){ 
    our_printf("entered value()\n"); 
    ++Trace_level; 
  } 
  
  if(Trace){ 
    sprintf(string,"point %p\timeslice %i\n",point,timeslice);
    our_printf(string); 
  } 
  
  if(timeslice == Timeslices-1){ 
    point->value_if_held = 0;
    point->value_if_exercised = payoff(point,timeslice);
    if(point->value_if_held > point->value_if_exercised){
      point->value = point->value_if_held;
    }else{
      point->value = point->value_if_exercised;
    }
    point->error = 0;
    point->delta_r            = point->value_if_exercised - point->value_if_held;
  }else{
    /* if the error is too large at this time add point */
    do{
      point_initialize(&scratch_point);
      grow_point(point->price, scratch_point.price);
      add_point_to_mesh(&scratch_point, point, timeslice+1);
      
      /* the new point is now the last point in the next timeslice */
      value( point, &(Time[timeslice+1].element[ Time[timeslice+1].elements-1 ]), timeslice+1);
      point->value_if_exercised = payoff(point, timeslice);
      point->value_if_held      = mesh_estimate_value(point, timeslice,&(point->error));
      if(point->value_if_held < 0){
	point->value_if_held = 0;
      }

      if(point->value_if_held > point->value_if_exercised){
	point->value = point->value_if_held;
      }else{
	point->value = point->value_if_exercised;
      }

      point->delta_r            = point->value_if_exercised - point->value_if_held;
      point_finalize(&scratch_point);
    }while(error_too_large(point, timeslice));
  }

  if(Trace){ 
    --Trace_level;
    our_printf("exiting value()\n"); 
  } 

}      
    
